package com.company;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Random;

public class Main {

    public static void main(String[] args) {
        ArrayList <Card> cards = new ArrayList<>();
        String Color; String Color1;
        for (int i = 1; i < 5; i++){
            switch (i){
                case 1:
                    Color = "Red";
                    break;
                case 2:
                    Color = "Yellow";
                    break;
                case 3:
                    Color = "Green";
                    break;
                case 4:
                    Color = "Blue";
                    break;
                default:
                    throw new IllegalStateException("Unexpected value: " + i);
            }
            for (int j = 0; j < 10; j++) {
                Numeric numeric = new Numeric(Color, 0, j);
                cards.add(numeric);
            }
            Skip skip = new Skip(Color, 1, 0);
            cards.add(skip);
            Reverse reverse = new Reverse(Color, 1, 1);
            cards.add(reverse);
            Draw draw = new Draw(Color, 1, 2);
            cards.add(draw);
            Black black = new Black("Black", 0);
            cards.add(black);
        }
        for (int i = 1; i < 5; i++){
            switch(i){
                case 1:
                    Color1 = "Red";
                    break;
                case 2:
                    Color1 = "Yellow";
                    break;
                case 3:
                    Color1 = "Green";
                    break;
                case 4:
                    Color1 = "Blue";
                    break;
                default:
                    throw new IllegalStateException("Unexpected value: " + i);
            }
            for (int j = 1; j < 10; j++) {
                Numeric numeric = new Numeric(Color1, 0, j);
                cards.add(numeric);
            }
            Skip skip = new Skip(Color1, 1, 0);
            cards.add(skip);
            Reverse reverse = new Reverse(Color1, 1, 1);
            cards.add(reverse);
            Draw draw = new Draw(Color1, 1, 2);
            cards.add(draw);
            WildDraw wildDraw = new WildDraw("Black", 1);
            cards.add(wildDraw);
        }
        //System.out.println(cards.size());
        /*for (int i = 0; i < 108; i++){
            System.out.println(cards.get(i).toString());
        }*/
        Random r = new Random(); int next;
        ArrayList<Player> players = new ArrayList<>();
        for (int i = 1; i < 5; i++) {
            Player p = new Player();
            players.add(p);
            for (int j = 1; j < 8; j++){
               next = r.nextInt(cards.size());
               p.getPlayerCards().add(cards.get(next));
               cards.remove(next);
                //System.out.println("cardNumber = " + next);
            }
            //p.printAllCards(i);
        }

        /*for (int i = 0; i < 4; i++) {
            players.get(i).printAllCards(i + 1);
            System.out.println(players.get(i).getPlayerPoint());

        }*/
        // first random card from the storage of cards (most be a colored card)
        next = r.nextInt(cards.size());
        if (cards.get(next) instanceof Black){
            while (cards.get(next) instanceof Black) {
                next = r.nextInt(cards.size());
            }
        }
        System.out.println("Player" + r.nextInt(5) + " starts the game");
        int move = 1; Player p = null;
        // starts a round
        while (true) {
            Iterator<Player> playerIterator = players.iterator();
            while (playerIterator.hasNext()){
                p = playerIterator.next();
                if (p.getPlayerCards().size() == 0)
                    break;
            }
            if (p.getPlayerCards().size() == 0)
               break;
            if (move == 1)
                System.out.println("Clockwise");
            else
                System.out.println("CounterClockwise");

        }
        // sort players by each player's point (Acsending sort)
        Iterator<Player> players1 = players.iterator(); int min = -1;
        while (players1.hasNext()){
            p = players1.next();
            if (p.getPlayerPoint() > min)
                min = p.getPlayerPoint();
        }
        // end the round by showing each player's point
        Iterator<Player> players2 = players.iterator(); int c = 0;
        while (players2.hasNext()){
            c++;
            players2.next().toString(c);
        }
        // unicode of black color:  "\033[0;30m"
        // unicode of red color:  "\033[0;31m"
        // unicode of green color:  "\033[0;32m"
        // unicode of yellow color:  "\033[0;33m"
        // unicode of blue color:  "\033[0;34m"
        // unicode of forbidden: "\u29B8"
        /*for (int i = 1; i < 4; i++){
            System.out.print("\033[0;31m" + "|");
            if ((i == 1) || (i == 3)){
                for (int j = 1; j < 6; j++)
                    System.out.print("$");
            }
            else{
                    System.out.print("  ");
                int s;
                if (i == 2) {
                    s = 0;
                    System.out.print("0");
                }
                else
                  s = 1;
                for (int j = 1; j < 3 + s; j++)
                    System.out.print(" ");
            }
            System.out.println("|");
        }*/
    }
}
