package com.company;

import java.util.ArrayList;
import java.util.Iterator;

public class Player {
    private ArrayList<Card> playerCards = new ArrayList<>();
    private int playerPoint;

    public ArrayList<Card> getPlayerCards() {
        return playerCards;
    }

    public void printAllCards(int playerNumber){
        System.out.println("Player" + playerNumber + ":");
        Iterator<Card> cardIterator = playerCards.iterator();
        while (cardIterator.hasNext()){
            Card c = cardIterator.next();
            System.out.println(c.toString());
        }
        System.out.println();
    }

    public int getPlayerPoint() {
        Iterator<Card> cardIterator = playerCards.iterator();
        while (cardIterator.hasNext()){
            playerPoint += cardIterator.next().getCardPoint();
        }
        return playerPoint;
    }

    public String toString(int playerNumber) {
        return "Player" + playerNumber +
                " {playerPoint=" + playerPoint +
                " }";
    }
}
